Index: drivers/s390/block/dasd.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/dasd.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/dasd.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/dasd.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -1143,87 +1352,147 @@
  * returns a ccw_req_t to the appropriate cache or emergeny request line
  */
 void
-dasd_free_request (ccw_req_t * request, dasd_device_t* device)
+dasd_free_request (ccw_req_t *cqr, dasd_device_t* device)
 {
+        unsigned long size_needed;
+        dasd_lowmem_t *lowmem;
+
 #ifdef CONFIG_ARCH_S390X
         ccw1_t* ccw;
-        /* clear any idals used for chain */
-        ccw=request->cpaddr-1;
+        /* clear any idals used for chain (might be in lowmen cqr page, */
+        /* in seperate lowmen page or kmalloced */
+        ccw=cqr->cpaddr-1;
         do {
                 ccw++;
-                if ((ccw->cda < (unsigned long) device->lowmem_idals           ) || 
-                    (ccw->cda >= (unsigned long) device->lowmem_idals+PAGE_SIZE)   )
-                        clear_normalized_cda (ccw);
-                else {
-                        if (device->lowmem_idal_ptr != device->lowmem_idals)
-                                DASD_MESSAGE (KERN_WARNING, device,
-                                              "Freeing emergency idals from request at %p.",
-                                              request);
-                        device->lowmem_idal_ptr = device->lowmem_idals;
-                        device->lowmem_cqr=NULL;
+                if ((cqr->flags & CQR_FLAGS_LM_CQR) &&
+                    (ccw->cda >= (unsigned long) cqr) &&
+                    (ccw->cda < (unsigned long) cqr + PAGE_SIZE)) {
+                    /* IDAL is on the car lowmem page */
+                        continue;
+                }
+
+                if ((cqr->flags & CQR_FLAGS_LM_IDAL) &&
+                    (ccw->cda >= (unsigned long) cqr->lowmem_idal) &&
+                    (ccw->cda < (unsigned long) cqr->lowmem_idal + PAGE_SIZE)) {
+                        /* IDAL is on seperate lowmem page */
+                        continue;
                 }
+
+                /* IDAL was build by set_normalized_cda */
+                clear_normalized_cda (ccw);
+
         } while ((ccw->flags & CCW_FLAG_CC) || 
                  (ccw->flags & CCW_FLAG_DC)   );
 #endif
-        if (request != device->lowmem_ccws) { 
-                /* compare to lowmem_ccws to protect usage of lowmem_cqr for IDAL only ! */
-		ccw_free_request (request);
-        } else {
-                DASD_MESSAGE (KERN_WARNING, device,
-                              "Freeing emergency request at %p",
-                              request);
-                device->lowmem_cqr=NULL;
-	}
+        /* give idal lowmem page back to lowmem_pool */
+        if (cqr->flags & CQR_FLAGS_LM_IDAL) {
+                lowmem = (dasd_lowmem_t *) cqr->lowmem_idal;
+                list_add (&lowmem->list, &device->lowmem_pool);
+                cqr->flags &= ~CQR_FLAGS_LM_IDAL;
+        }
+                
+        /* give cqr lowmem pages back to lowmem_pool */
+        if (cqr->flags & CQR_FLAGS_LM_CQR) { 
+                
+                /* make the same decisions as in dasd_alloc_request */
+                size_needed = (sizeof (ccw_req_t) + 7) & (~7L);
+                if (size_needed + cqr->datasize <= PAGE_SIZE) {
+                        /* We kept the data with the request */
+                        size_needed += (cqr->datasize + 7) & (~7L);
+                } else {
+                        lowmem = (dasd_lowmem_t *) cqr->data;
+                        list_add (&lowmem->list, &device->lowmem_pool);
+                }
+                
+                if (size_needed + cqr->cplength * sizeof(ccw1_t) > PAGE_SIZE) {
+                        /* We didn't keep the CCWs with request */
+                        lowmem = (dasd_lowmem_t *) cqr->cpaddr;
+                        list_add (&lowmem->list, &device->lowmem_pool);
+                }
+                lowmem = (dasd_lowmem_t *) cqr;
+                list_add (&lowmem->list, &device->lowmem_pool);
+	} else {
+                ccw_free_request (cqr);
+        }
 }
 
+/*
+ * function dasd_set_normalized_cda
+ * calls set_normalized_cda to build IDALs.
+ * If this did not work because of low memory, we try to use memory from the 
+ * lowmem pool.
+ */
 int
-dasd_set_normalized_cda (ccw1_t * cp, unsigned long address, 
-                         ccw_req_t* request, dasd_device_t* device )
+dasd_set_normalized_cda (ccw1_t *cp, unsigned long address, 
+                         ccw_req_t *cqr, dasd_device_t *device)
 {
 #ifdef CONFIG_ARCH_S390X
+        int rc;
 	int nridaws;
+        dasd_lowmem_t *lowmem;
         int count = cp->count;
         
-        if (set_normalized_cda (cp, address)!=-ENOMEM) {
-                return 0;
-        }
-
-        if ((device->lowmem_cqr!=NULL) && (device->lowmem_cqr!=request)) {
-                DASD_MESSAGE (KERN_WARNING, device, 
-                              "Refusing emergency idals for request %p, memory"
-                              " is already in use for request %p",
-                              request,
-                              device->lowmem_cqr);
-                return -ENOMEM;
-        }
-        device->lowmem_cqr=request;
-        if (device->lowmem_idal_ptr == device->lowmem_idals) {
-            DASD_MESSAGE (KERN_WARNING,device, 
-                          "Low memory! Using emergency IDALs for request %p.\n",
-                          request);
+        /* use lowmem idal page if already assinged */
+        if (!(cqr->flags & CQR_FLAGS_LM_IDAL)) {
+                rc = set_normalized_cda (cp, (void *)address);
+                if (rc !=-ENOMEM) {
+                        return rc;
+                }
         }
+        
+        /* get number of idal words needed */
         nridaws = ((address & (IDA_BLOCK_SIZE-1)) + count + 
 		   (IDA_BLOCK_SIZE-1)) >> IDA_SIZE_LOG;
-	if ( device->lowmem_idal_ptr>=device->lowmem_idals + PAGE_SIZE ) {
-		/* Ouch! No Idals left for emergency request */
-		BUG();
-	}
+
+        /* check if we need an additional IDALs page */
+	if (!(cqr->flags & CQR_FLAGS_LM_IDAL)) {
+                /* we got no lowmem cqr page OR */
+                /* there is no space left for IDALs */
+                if ((!(cqr->flags & CQR_FLAGS_LM_CQR)) ||
+                    ((cqr->lowmem_idal_ptr + nridaws * sizeof(unsigned long)) > 
+                     ((void *) cqr + PAGE_SIZE))) {
+                        
+                        /* use lowmem page only for ERP or */
+                        /* if there are less than 2 requests on queue */
+                        if (device->queue.head != NULL &&
+                            device->queue.head->next != NULL &&
+                            device->queue.head->status != CQR_STATUS_ERROR) {
+                                return -ENOMEM;
+                        }
+                       
+                        list_for_each_entry (lowmem, &device->lowmem_pool, 
+                                             list) {
+                                list_del (&lowmem->list);
+                                cqr->lowmem_idal = (void *)lowmem;
+                                cqr->lowmem_idal_ptr  = (void *) lowmem;
+                                memset (cqr->lowmem_idal, 0, PAGE_SIZE);
+                                cqr->flags |= CQR_FLAGS_LM_IDAL;
+                                break;
+                        }
+                }
+                
+        }
+        
+        /* now we (should) have an valid lowmem_idal_ptr and enough space for */
+        /* the IDALs - fill the idals table */
 	cp->flags |= CCW_FLAG_IDA;
-	cp->cda = (__u32)(unsigned long)device->lowmem_idal_ptr;
+	cp->cda = (__u32)(unsigned long)cqr->lowmem_idal_ptr;
         do {
-		*((long*)device->lowmem_idal_ptr) = address;
-		address = (address & -(IDA_BLOCK_SIZE)) + (IDA_BLOCK_SIZE);
+		*((long*)cqr->lowmem_idal_ptr) = address;
+		address  = (address & -(IDA_BLOCK_SIZE)) + (IDA_BLOCK_SIZE);
+                cqr->lowmem_idal_ptr += sizeof(unsigned long);
 		nridaws --;
-                device->lowmem_idal_ptr += sizeof(unsigned long);
         } while ( nridaws > 0 );
 #else 
-        cp -> cda = address;
+        cp->cda = address;
 #endif
 	return 0;
 }
 
 
-/* SECTION: (de)queueing of requests to channel program queues */
+/********************************************************************************
+ * SECTION: (de)queueing of requests to channel program queues 
+ ********************************************************************************/
 
 /*
  * function dasd_chanq_enq
@@ -1245,22 +1514,26 @@
 
        
 #ifdef DASD_PROFILE
-        /* save profile information for non erp cqr */
-        if (cqr->refers == NULL) {
-                unsigned int  counter = 0;
-                ccw_req_t     *ptr;
-                dasd_device_t *device = cqr->device;
-
-                /* count the length of the chanq for statistics */
-                for (ptr = q->head; 
-                     ptr->next != NULL && counter <=31; 
-                     ptr = ptr->next) {
-                        counter++;
-                }                
-                
-                dasd_global_profile.dasd_io_nr_req[counter]++;
-                device->profile.dasd_io_nr_req[counter]++;
-        }
+        if (dasd_profile_level == DASD_PROFILE_ON) {
+
+                /* save profile information for non erp cqr */
+                if (cqr->refers == NULL) {
+                        unsigned int  counter = 0;
+                        ccw_req_t     *ptr;
+                        dasd_device_t *device = cqr->device;
+                        
+                        /* count the length of the chanq for statistics */
+                        for (ptr = q->head; 
+                             ptr->next != NULL && counter <=31; 
+                             ptr = ptr->next) {
+                                counter++;
+                        }                
+                        
+                        dasd_global_profile.dasd_io_nr_req[counter]++;
+                        device->profile.dasd_io_nr_req[counter]++;
+                }
+
+        } /* end if DASD_PROFILE_ON */
 #endif 
 }
 
@@ -1276,7 +1549,10 @@
 	q->head = cqr;
 	if (q->tail == NULL)
 		q->tail = cqr;
-	check_then_set (&cqr->status, CQR_STATUS_FILLED, CQR_STATUS_QUEUED);
+
+	check_then_set (&cqr->status, 
+                        CQR_STATUS_FILLED, 
+                        CQR_STATUS_QUEUED);
 }
 
 /*
@@ -1302,7 +1578,7 @@
 		while (prev && prev->next != cqr)
 			prev = prev->next;
 		if (prev == NULL)
-			return;
+			return; /* request not in chanq */
 		prev->next = cqr->next;
 		if (prev->next == NULL)
 			q->tail = prev;
@@ -1310,7 +1586,87 @@
 	cqr->next = NULL;
 }
 
-/* SECTION: Managing the device queues etc. */
+/********************************************************************************
+ * SECTION: Managing the device queues etc. 
+ ********************************************************************************/
+
+/*
+ * DASD_RESREL_TIMEOUT
+ *
+ * A timer is used to suspend the current reserve/release request 
+ * if it doesn't return within a certain time.
+ */
+void
+dasd_resrel_timeout (unsigned long cqr_ptr)
+{
+        dasd_device_t *device = ((ccw_req_t *) cqr_ptr)->device;
+        ccw_req_t     *cqr;
+	unsigned long flags;
+
+	s390irq_spin_lock_irqsave (device->devinfo.irq, 
+                                   flags);
+        cqr = device->queue.head;
+
+        switch (cqr->status) {
+        case CQR_STATUS_FILLED:
+        case CQR_STATUS_QUEUED:
+                /* request was not started - just set to failed */
+                cqr->status = CQR_STATUS_FAILED;
+                break;
+
+        case CQR_STATUS_IN_IO:
+        case CQR_STATUS_ERROR:        
+                if (device->discipline->term_IO (cqr) != 0);
+                        cqr->status = CQR_STATUS_FAILED;
+                break;
+
+        default:
+                ; /* DONE and FAILED are ok */
+        }
+
+        dasd_schedule_bh (device);
+
+        s390irq_spin_unlock_irqrestore (device->devinfo.irq, 
+                                        flags);
+
+} /* end dasd_resrel_timeout */
+
+/*
+ * Call unconditional reserve to break the reserve of an other system.
+ * Timeout the request if it doesn't succseed within a certain time.
+ */
+static int 
+dasd_steal_lock (dasd_device_t *device)
+{
+        ccw_req_t *cqr;
+        int rc = 0;
+
+        if (!device->discipline->steal_lock) 
+                rc = -EINVAL;
+        
+        cqr = device->discipline->steal_lock (device);
+        
+        if (cqr) {
+                struct timer_list res_timer;
+                
+                init_timer(&res_timer);
+                res_timer.function = dasd_resrel_timeout; 
+                res_timer.data     = (unsigned long) cqr;
+                res_timer.expires  = jiffies + 4 * HZ; 
+                add_timer(&res_timer);
+                
+                rc = dasd_sleep_on_immediate (cqr);
+                
+                del_timer_sync(&res_timer); 
+                dasd_free_request (cqr, 
+                                   device);
+        } else {
+                rc = -ENOMEM;
+        }
+
+        return rc;
+
+} /* end dasd_steal_lock */
 
 /*
  * DASD_TERM_IO
@@ -1331,55 +1687,57 @@
 		BUG ();
 	}
 	irq = device->devinfo.irq;
-	if (strncmp ((char *) &cqr->magic, device->discipline->ebcname, 4)) {
-		DASD_MESSAGE (KERN_WARNING, device,
-			      " ccw_req_t 0x%08x magic doesn't match"
-			      " discipline 0x%08x\n",
-			      cqr->magic,
-			      *(unsigned int *) device->discipline->name);
+	if (strncmp ((char *) &cqr->magic, 
+                     device->discipline->ebcname, 4)) {
+
+		DEV_MESSAGE (KERN_WARNING, device,
+                             " ccw_req_t 0x%08x magic doesn't match"
+                             " discipline 0x%08x",
+                             cqr->magic,
+                             *(unsigned int *) device->discipline->name);
+
 		return -EINVAL;
 	}
         
         while ((retries < 5                    ) &&
                (cqr->status == CQR_STATUS_IN_IO)   ) {
 
-                if ( retries < 2 )
-                        rc = halt_IO(irq, (long)cqr, 
-                                     cqr->options | DOIO_WAIT_FOR_INTERRUPT);
-                else
-                        rc = clear_IO(irq, (long)cqr, 
-                                      cqr->options | DOIO_WAIT_FOR_INTERRUPT);
-
+                rc = clear_IO (irq, 
+                               (long)cqr, 
+                               cqr->options);
+                
                 switch (rc) {
                 case 0:         /* termination successful */
                         check_then_set (&cqr->status,
                                         CQR_STATUS_IN_IO, 
                                         CQR_STATUS_FAILED);
                         
-                        asm volatile ("STCK %0":"=m" (cqr->stopclk));
+                        cqr->stopclk = get_clock ();
+
                         break;
                 case -ENODEV:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "device gone, retry\n");
+                        DBF_DEV_EVENT (DBF_ERR, device, "%s",
+                                       "device gone, retry");
                         break;
                 case -EIO:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "I/O error, retry\n");
+                        DBF_DEV_EVENT (DBF_ERR, device, "%s",
+                                       "I/O error, retry");
                         break;
                 case -EBUSY:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "device busy, retry later\n");
+                        DBF_DEV_EVENT (DBF_ERR, device, "%s",
+                                       "device busy, retry later");
                         break;
                 default:
-                        DASD_MESSAGE (KERN_ERR, device,
-                                      "line %d unknown RC=%d, please report"
-                                      " to linux390@de.ibm.com\n", 
-                                      __LINE__, 
-                                      rc);
+                        DEV_MESSAGE (KERN_ERR, device,
+                                     "line %d unknown RC=%d, please "
+                                     "report to linux390@de.ibm.com", 
+                                     __LINE__, 
+                                     rc);
                         BUG ();
                         break;
                 }
 
+                dasd_schedule_bh (device);
                 retries ++;
         }
 	return rc;
@@ -1401,27 +1759,30 @@
 		BUG ();
 	}
 	irq = device->devinfo.irq;
-	if (strncmp ((char *) &cqr->magic, device->discipline->ebcname, 4)) {
-		DASD_MESSAGE (KERN_WARNING, device,
-			      " ccw_req_t 0x%08x magic doesn't match"
-			      " discipline 0x%08x\n",
-			      cqr->magic,
-			      *(unsigned int *) device->discipline->name);
+	if (strncmp ((char *) &cqr->magic, 
+                     device->discipline->ebcname, 4)) {
+
+		DEV_MESSAGE (KERN_ERR, device,
+                             " ccw_req_t 0x%08x magic doesn't match"
+                             " discipline 0x%08x",
+                             cqr->magic,
+                             *(unsigned int *) device->discipline->name);
+
 		return -EINVAL;
 	}
 
-	asm volatile ("STCK %0":"=m" (now));
-        cqr->startclk = now;
+	now = get_clock ();
 
-	rc = do_IO (irq, cqr->cpaddr, (long) cqr, cqr->lpm, cqr->options);
+        cqr->startclk = now;
+        if (!device->stopped)
+                rc = do_IO (irq, cqr->cpaddr, (long) cqr, cqr->lpm, cqr->options);
+        else
+                rc = -EBUSY;
 
 	switch (rc) {
 	case 0:
                 if (cqr->options & DOIO_WAIT_FOR_INTERRUPT) {
                         /* request already finished (synchronous IO) */
-                        DASD_MESSAGE (KERN_ERR, device, "%s",
-                                      " do_IO finished request... "
-                                      "DOIO_WAIT_FOR_INTERRUPT was set");
                         check_then_set (&cqr->status,
                                         CQR_STATUS_QUEUED, 
                                         CQR_STATUS_DONE);
@@ -1436,12 +1797,22 @@
                 }
 		break;
 	case -EBUSY:
-		DASD_MESSAGE (KERN_WARNING, device, "%s",
-			      "device busy, retry later\n");
+		DBF_DEV_EVENT (DBF_ERR, device, "%s",
+                               "device busy, retry later");
+
+                if (!timer_pending(&device->timer)) {
+                        init_timer (&device->timer);
+                        device->timer.function = dasd_schedule_bh_timed; 
+                        device->timer.data     = (unsigned long) device;
+                        device->timer.expires  = jiffies + (HZ >> 4);
+                        add_timer (&device->timer);
+                } else {
+                        mod_timer(&device->timer, jiffies + (HZ >> 4));
+                }
 		break;
 	case -ETIMEDOUT: 
-		DASD_MESSAGE (KERN_WARNING, device, "%s",
-			      "request timeout - terminated\n");
+		DBF_DEV_EVENT (DBF_ERR, device, "%s",
+                               "request timeout - terminated");
 	case -ENODEV:
 	case -EIO:
 		check_then_set (&cqr->status,
@@ -1452,9 +1823,11 @@
                 dasd_schedule_bh (device);
 		break;
 	default:
-		DASD_MESSAGE (KERN_ERR, device,
-			      "line %d unknown RC=%d, please report"
-			      " to linux390@de.ibm.com\n", __LINE__, rc);
+		DEV_MESSAGE (KERN_ERR, device,
+                             "line %d unknown RC=%d, please report"
+                             " to linux390@de.ibm.com",
+                             __LINE__, 
+                             rc);
 		BUG ();
 		break;
 	}
@@ -1465,43 +1838,83 @@
 /*
  * function dasd_sleep_on_req
  * attempts to start the IO and waits for completion
- * FIXME: replace handmade sleeping by wait_event
  */
 int
-dasd_sleep_on_req (ccw_req_t * req)
+dasd_sleep_on_req (ccw_req_t * cqr)
 {
 	unsigned long flags;
-	int cs;
-	int rc = 0;
-	dasd_device_t *device = (dasd_device_t *) req->device;
+	dasd_device_t *device = (dasd_device_t *) cqr->device;
 
-        if ( signal_pending(current) ) {
+        if (signal_pending(current)) {
                 return -ERESTARTSYS;
         }
-	s390irq_spin_lock_irqsave (device->devinfo.irq, flags);
-	dasd_chanq_enq (&device->queue, req);
+	s390irq_spin_lock_irqsave (device->devinfo.irq, 
+                                   flags);
+        
+	dasd_chanq_enq (&device->queue, 
+                        cqr);
+
 	/* let the bh start the request to keep them in order */
 	dasd_schedule_bh (device);
-	do {
-		s390irq_spin_unlock_irqrestore (device->devinfo.irq, flags);
-		wait_event ( device->wait_q,
-			     (((cs = req->status) == CQR_STATUS_DONE) ||
-			     (cs == CQR_STATUS_FAILED) ||
-                             signal_pending(current)));
-		s390irq_spin_lock_irqsave (device->devinfo.irq, flags);
-                if ( signal_pending(current) ) {
-                        rc = -ERESTARTSYS;
-		     	if (req->status == CQR_STATUS_IN_IO ) 
-                        	device->discipline->term_IO(req);
-                        break;
-                } else if ( req->status == CQR_STATUS_FAILED) {
-                        rc = -EIO;
-                        break;
-                }
-	} while (cs != CQR_STATUS_DONE && cs != CQR_STATUS_FAILED);
-	s390irq_spin_unlock_irqrestore (device->devinfo.irq, flags);
-	return rc;
-}				/* end dasd_sleep_on_req */
+
+        s390irq_spin_unlock_irqrestore (device->devinfo.irq, 
+                                        flags);
+
+        wait_event (device->wait_q,
+                    cqr->flags & CQR_FLAGS_FINALIZED); 
+
+        if (cqr->status == CQR_STATUS_FAILED) {
+                return -EIO;
+        }
+
+	return 0;
+
+} /* end dasd_sleep_on_req */
+
+/*
+ * function dasd_sleep_on_immediate
+ * same as dasd_sleep_on_req, but attempts to start the IO immediately 
+ * (killing the actual running IO). 
+ */
+static int
+dasd_sleep_on_immediate (ccw_req_t *cqr)
+{
+	unsigned long flags;
+	dasd_device_t *device = (dasd_device_t *) cqr->device;
+
+        if (signal_pending(current))
+                return -ERESTARTSYS;
+
+	s390irq_spin_lock_irqsave (device->devinfo.irq, 
+                                   flags);
+        
+        /* terminate currently running IO */
+        if (device->queue.head->status == CQR_STATUS_IN_IO) {
+
+                device->discipline->term_IO (device->queue.head);
+
+                device->queue.head->status = CQR_STATUS_QUEUED;
+        }
+
+	dasd_chanq_enq_head (&device->queue, 
+                             cqr);
+
+	/* let the bh start the request to keep them in order */
+	dasd_schedule_bh (device);
+
+        s390irq_spin_unlock_irqrestore (device->devinfo.irq, 
+                                        flags);
+        
+        wait_event (device->wait_q,
+                    cqr->flags & CQR_FLAGS_FINALIZED); 
+        
+        if (cqr->status == CQR_STATUS_FAILED) {
+                return -EIO;
+        }
+
+	return 0;
+
+} /* end dasd_sleep_on_immediate */
 
 /*
  * function dasd_end_request
@@ -1547,14 +1960,19 @@
 	unsigned long long now;
 	int rc = 0;
 
-	asm volatile ("STCK %0":"=m" (now));
-	if (cqr->expires && cqr->expires + cqr->startclk < now) {
-		DASD_MESSAGE (KERN_ERR, ((dasd_device_t *) cqr->device),
-			      "IO timeout 0x%08lx%08lx usecs in req %p\n",
-			      (long) (cqr->expires >> 44),
-			      (long) (cqr->expires >> 12), cqr);
-		cqr->expires <<= 1;
-                rc = -EIO;
+	now = get_clock ();
+
+	if (cqr->expires && 
+            cqr->expires + cqr->startclk < now) {
+
+		DBF_DEV_EVENT (DBF_WARNING, ((dasd_device_t *) cqr->device),
+                               "IO timeout 0x%08lx%08lx usecs in req %p",
+                               (long) (cqr->expires >> 44),
+                               (long) (cqr->expires >> 12), 
+                               cqr);
+
+		cqr->expires <<= 1;
+                rc = -EIO;
 	}
 	return rc;
 }
@@ -1569,22 +1987,36 @@
 {
 	dasd_device_t *device = cqr->device;
 
-	asm volatile ("STCK %0":"=m" (cqr->endclk));
+	cqr->endclk = get_clock ();
+
 	if (cqr->req) {
+
 #ifdef DASD_PROFILE
-		dasd_profile_add (cqr);
+                if (dasd_profile_level == DASD_PROFILE_ON) {
+                        dasd_profile_add (cqr);
+                }
 #endif
+
 		dasd_end_request (cqr->req, (cqr->status == CQR_STATUS_DONE));
 		/* free request if nobody is waiting on it */
 		dasd_free_request (cqr, cqr->device);
 	} else {
-                if ( cqr == device->init_cqr && /* bring late devices online */
-                     device->level <= DASD_STATE_ONLINE ) { 
-                        device->timer.function = dasd_enable_single_device; 
-                        device->timer.data     = (unsigned long) device;
-                        device->timer.expires  = jiffies;
-                        add_timer(&device->timer);
+                if (cqr == device->init_cqr && /* bring late devices online */
+                    device->level <= DASD_STATE_ONLINE ) { 
+                        if (!timer_pending(&device->late_timer)) {
+                                init_timer(&device->late_timer);
+                                device->late_timer.function = dasd_enable_single_device; 
+                                device->late_timer.data     = (unsigned long) device;
+                                device->late_timer.expires  = jiffies;
+                                add_timer(&device->late_timer);
+                        } else {
+                                mod_timer(&device->late_timer, jiffies);
+                        }
+                } else {
+                        /* notify sleep_on_xxx about finished cqr */
+                        cqr->flags |= CQR_FLAGS_FINALIZED;
                 }
+
 		/* notify sleeping task about finished postprocessing */
 		wake_up (&device->wait_q);
                 
@@ -1606,12 +2038,10 @@
 	dasd_chanq_t *qp = &device->queue;
 	int irq = device->devinfo.irq;
 	ccw_req_t *final_requests = NULL;
-	static int chanq_min_size = DASD_MIN_SIZE_FOR_QUEUE;
 	int chanq_max_size = DASD_CHANQ_MAX_SIZE;
 	ccw_req_t *cqr = NULL, *temp;
 	dasd_erp_postaction_fn_t erp_postaction;
 
-
 	s390irq_spin_lock_irqsave (irq, flags);
 
 	/* First we dechain the requests, processed with completed status */
@@ -1628,16 +2058,10 @@
 
                         qp->head->retries--; 
 
-			if (qp->head->dstat->flag & DEVSTAT_HALT_FUNCTION) {
-
-                                check_then_set (&qp->head->status,
-                                                CQR_STATUS_ERROR,
-                                                CQR_STATUS_FAILED);
-
-                                asm volatile ("STCK %0":"=m" (qp->head->stopclk));
-
-                        } else if ((device->discipline->erp_action == NULL                          ) ||
-                                   ((erp_action = device->discipline->erp_action (qp->head)) == NULL)   ) {
+			if ((qp->head->dstat == NULL                                         ) ||
+			    ((qp->head->dstat->flag & DEVSTAT_FLAG_SENSE_AVAIL) == 0         ) ||
+			    (device->discipline->erp_action == NULL                          ) ||
+			    ((erp_action = device->discipline->erp_action (qp->head)) == NULL)   ) {
                                 
 				erp_cqr = dasd_default_erp_action (qp->head);
 
@@ -1651,12 +2075,12 @@
 
 			if (qp->head->status == CQR_STATUS_DONE) {
 
-                                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                                              "ERP successful");
+                                DBF_DEV_EVENT (DBF_NOTICE, device, "%s",
+                                               "ERP successful");
 			} else {
 
-                                DASD_MESSAGE (KERN_ERR, device, "%s",
-                                              "ERP unsuccessful");
+                                DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                             "ERP unsuccessful");
 			}
 
 			if ((device->discipline->erp_postaction == NULL                              )||
